#!/usr/bin/perl

use strict;
use warnings;

use SOAP::Lite +trace => 'debug';
use MIME::Base64;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/ConfigurationManagement.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");

my $som = $soap->call('RetrieveContactKeysList');

if ($som->fault) {
    my $code = $som->faultcode;
    my $actor = $som->faultactor;
    my $string = $som->faultstring;
    my $detail = $som->faultdetail;
    my $out = "Fault\n";
    $out .= "\tCode\t$code\n" if ($code);
    $out .= "\tActor\t$actor\n" if ($actor);
    $out .= "\tString\t$string\n" if ($string);
    $out .= "\tDetail\t$detail\n" if ($detail);
    die $out;
}

print $som->valueof('//RetrieveContactKeysListResponse/keys') . "\n";
